var oFormScope;

/**
 * constructor_form
 * Fonction appelé à l'initialisation du formulaire
 * @param {type} scope
 */
 constructor_form = function (scope) {
    console.log("constructor_form");

    oFormScope = scope;
};

/**
 * Charge la liste des schemas
 */
 angular.element(vitisApp.appMainDrtv).scope()["loadVMapBoFormSchemas"] = function(){
    console.log('loadVMapBoFormSchemas');

    if (!angular.isDefined(oFormScope['oFormValues'])) {
        return;
    }

    var oFormValues = oFormScope['oFormValues'][oFormScope['sFormDefinitionName']];
    if (!angular.isDefined(oFormValues)) {
        return;
    }

    var sDatabase = oFormValues['database'];
    if (angular.isDefined(sDatabase['selectedOption'])) {
        if (angular.isDefined(sDatabase['selectedOption']['value'])) {
            sDatabase = sDatabase['selectedOption']['value'];
        }
    }
    if (!angular.isString(sDatabase)) {
        $.notify('Base de données incorrecte');
        return;
    } else if (!sDatabase.length > 0) {
        $.notify('Base de données incorrecte');
        return;
    }

    ajaxRequest({
        'method': 'GET',
        'url': oFormScope['oProperties']['web_server_name'] + '/' +  oFormScope['oProperties']['services_alias'] + '/vitis/genericquerys/' + sDatabase + '/schemas',
        'params': {
            'distinct':true,
            'order_by':'schema_name',
            'sort_order':'ASC'
        },
        'scope': oFormScope,
        'success': function (response) {

            var aSchemasOptions = [];
            if (angular.isDefined(response['data'])) {
                if (angular.isArray(response['data']['genericquerys'])) {
                    for (var i = 0; i < response['data']['genericquerys'].length; i++) {
                        aSchemasOptions.push({
                            'label': response['data']['genericquerys'][i]['schema_name'],
                            'value': response['data']['genericquerys'][i]['schema_name']
                        });
                    }
                }
            }

            oFormScope.$applyAsync(function(){
                if (angular.isDefined(oFormValues['schema'])) {
                    if (angular.isDefined(oFormValues['schema']['options'])) {
                        oFormValues['schema']['options'] = aSchemasOptions;
                    }
                }
            });

        },
        'error': function (error){
            console.error('error', error);
        }
    });
};

/**
 * Charge la liste des tables
 */
 angular.element(vitisApp.appMainDrtv).scope()["loadVMapBoFormTables"] = function(){
    console.log('loadVMapBoFormTables');

    if (!angular.isDefined(oFormScope['oFormValues'])) {
        return;
    }

    var oFormValues = oFormScope['oFormValues'][oFormScope['sFormDefinitionName']];
    if (!angular.isDefined(oFormValues)) {
        return;
    }

    var sDatabase = oFormValues['database'];
    if (angular.isDefined(sDatabase['selectedOption'])) {
        if (angular.isDefined(sDatabase['selectedOption']['value'])) {
            sDatabase = sDatabase['selectedOption']['value'];
        }
    }
    if (!angular.isString(sDatabase)) {
        $.notify('Base de données incorrecte');
        return;
    } else if (!sDatabase.length > 0) {
        $.notify('Base de données incorrecte');
        return;
    }

    var sSchema = oFormValues['schema'];
    if (angular.isDefined(sSchema['selectedOption'])) {
        if (angular.isDefined(sSchema['selectedOption']['value'])) {
            sSchema = sSchema['selectedOption']['value'];
        }
    }
    if (!angular.isString(sSchema)) {
        $.notify('Nom du schema incorrect');
        return;
    } else if (!sSchema.length > 0) {
        $.notify('Nom du schema incorrect');
        return;
    }

    ajaxRequest({
        'method': 'GET',
        'url': oFormScope['oProperties']['web_server_name'] + '/' +  oFormScope['oProperties']['services_alias'] + '/vitis/genericquerys',
        'params': {
            'database':sDatabase,
            'schema':sSchema,
            'distinct':true,
            'order_by':'table_name',
            'sort_order':'ASC'
        },
        'scope': oFormScope,
        'success': function (response) {

            var aTablesOptions = [];
            if (angular.isDefined(response['data'])) {
                if (angular.isArray(response['data']['genericquerys'])) {
                    for (var i = 0; i < response['data']['genericquerys'].length; i++) {
                        aTablesOptions.push({
                            'label': response['data']['genericquerys'][i]['table_name'],
                            'value': response['data']['genericquerys'][i]['table_name']
                        });
                    }
                }
            }

            oFormScope.$applyAsync(function(){
                if (angular.isDefined(oFormValues['table'])) {
                    if (angular.isDefined(oFormValues['table']['options'])) {
                        oFormValues['table']['options'] = aTablesOptions;
                    }
                }
            });

        },
        'error': function (error){
            console.error('error', error);
        }
    });
};

/**
 * Charge la liste des colonnes
 */
 angular.element(vitisApp.appMainDrtv).scope()["loadVMapBoFormColumns"] = function(){
    console.log('loadVMapBoFormColumns');

    if (!angular.isDefined(oFormScope['oFormValues'])) {
        return;
    }

    var oFormValues = oFormScope['oFormValues'][oFormScope['sFormDefinitionName']];
    if (!angular.isDefined(oFormValues)) {
        return;
    }

    var sDatabase = oFormValues['database'];
    if (angular.isDefined(sDatabase['selectedOption'])) {
        if (angular.isDefined(sDatabase['selectedOption']['value'])) {
            sDatabase = sDatabase['selectedOption']['value'];
        }
    }
    if (!angular.isString(sDatabase)) {
        $.notify('Base de données incorrecte');
        return;
    } else if (!sDatabase.length > 0) {
        $.notify('Base de données incorrecte');
        return;
    }

    var sSchema = oFormValues['schema'];
    if (angular.isDefined(sSchema['selectedOption'])) {
        if (angular.isDefined(sSchema['selectedOption']['value'])) {
            sSchema = sSchema['selectedOption']['value'];
        }
    }
    if (!angular.isString(sSchema)) {
        $.notify('Nom du schema incorrect');
        return;
    } else if (!sSchema.length > 0) {
        $.notify('Nom du schema incorrect');
        return;
    }

    var sTable = oFormValues['table'];
    if (angular.isDefined(sTable['selectedOption'])) {
        if (angular.isDefined(sTable['selectedOption']['value'])) {
            sTable = sTable['selectedOption']['value'];
        }
    }
    if (!angular.isString(sTable)) {
        $.notify('Table incorrecte');
        return;
    } else if (!sTable.length > 0) {
        $.notify('Table incorrecte');
        return;
    }

    ajaxRequest({
        'method': 'GET',
        'url': oFormScope['oProperties']['web_server_name'] + '/' +  oFormScope['oProperties']['services_alias'] + '/vitis/genericquerys/workspace/columns',
        'params': {
            'database':sDatabase,
            'schema':sSchema,
            'table':sTable,
            'distinct':true,
            'order_by':'column_name',
            'sort_order':'ASC'
        },
        'scope': oFormScope,
        'success': function (response) {

            var aColumnsOptions = [];
            if (angular.isDefined(response['data'])) {
                if (angular.isArray(response['data']['genericquerys'])) {
                    for (var i = 0; i < response['data']['genericquerys'].length; i++) {
                        aColumnsOptions.push({
                            'label': response['data']['genericquerys'][i]['column_name'],
                            'value': response['data']['genericquerys'][i]['column_name']
                        });
                    }
                }
            }

            oFormScope.$applyAsync(function(){
                if (angular.isDefined(oFormValues['id_field'])) {
                    if (angular.isDefined(oFormValues['id_field']['options'])) {
                        oFormValues['id_field']['options'] = aColumnsOptions;
                    }
                }
                if (angular.isDefined(oFormValues['geom_column'])) {
                    if (angular.isDefined(oFormValues['geom_column']['options'])) {
                        oFormValues['geom_column']['options'] = aColumnsOptions;
                    }
                }
                if (angular.isDefined(oFormValues['search_field'])) {
                    if (angular.isDefined(oFormValues['search_field']['options'])) {
                        oFormValues['search_field']['options'] = aColumnsOptions;
                    }
                }
                if (angular.isDefined(oFormValues['result_field'])) {
                    if (angular.isDefined(oFormValues['result_field']['options'])) {
                        oFormValues['result_field']['options'] = aColumnsOptions;
                    }
                }
            });

        },
        'error': function (error){
            console.error('error', error);
        }
    });
};
